<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use App\Http\Services\AdministratorgroupaccessService;
use App\Http\Services\AdministratormenuService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\RolesService;
use App\Http\Validators\RolesValidator;
use App\Http\Services\ActivitylogService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\ItemcategoryService;

class RolesController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $menuService;
    private $activityLog;
    private $lokasiitem;
    private $itemcategory;

    /**
     * Roles constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService  = new RolesService();
        $this->validator    = new RolesValidator();
        $this->menuService  = new AdministratormenuService();
        $this->activityLog  = new ActivitylogService();
        $this->lokasiitem   = new LokasiitemService();
        $this->itemcategory   = new ItemcategoryService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $ID = $this->baseService->createNewGroup($request->all());

            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                                "username" => $auth->username, 
                                "urlTransaksi" => "roles", 
                                "namaTransaksi" => "Roles", 
                                "date" => date("Y-m-d H:i:s"), 
                                "activity" => "CREATE", 
                                "refId" => $ID, 
                                "date_updated" => date("Y-m-d H:i:s"), 
                                "kapalId" => $auth->kapalId, 
                                "deskripsi" => $auth->name . " just <b>created</b> new Role <a href=\"" . url("administrator/roles/" . $ID) . "\">here</a>"
                            ];
            $this->activityLog->store($activityLog);
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/roles")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "roleName" => "roleName"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "roleName" => "roleName"
        ];
        $this->data["ordering"] = [
            "roleName:asc" => "Role Name &uarr;"
           , "roleName:desc" => "Role Name &darr;"
        ];
        $this->data["roless"] = $this->baseService->paging($request);
        return view("modules.roles.roles_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit(Request $request, $id)
    {
        $auth = json_decode($request->session()->get('auth'));
		if($auth->aplikasi == "HO") {
            $this->data["roles"] = $this->baseService->show($id);
            $this->menuService->model->getQuery()->join("administratormenu as parent", "parent.id", "=", "administratormenu.parentmenu");
            $this->menuService->model->getQuery()->select(["administratormenu.*", "parent.menuname as parentMenu", "parent.id as parentID"])->where("administratormenu.active", "=", 1)->orderBy("parentID", "ASC");
            $this->data["access"] = $this->menuService->index();
            $this->data["groupHasAccess"] = (new AdministratorgroupaccessService())->model->getQuery()->where("administratorgroupaccess.groupid", "=", $this->data["roles"]->id)->get();

        $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        $this->data["groupHasSubinv"] = $this->baseService->groupHasSubinv($this->data["roles"]->id);

        $this->data["categories"] = $this->itemcategory->index($request);
        $this->data["groupHasCategories"] = $this->baseService->groupHasCategories($this->data["roles"]->id);

        return view("modules.roles.roles_edit", $this->data);
        }
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->updateGroup($id, $request->all());

            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                                "username" => $auth->username, 
                                "urlTransaksi" => "roles", 
                                "namaTransaksi" => "Roles", 
                                "date" => date("Y-m-d H:i:s"), 
                                "activity" => "UPDATE", 
                                "refId" => $id, 
                                "date_updated" => date("Y-m-d H:i:s"), 
                                "kapalId" => $auth->kapalId, 
                                "deskripsi" => $auth->name . " just <b>updated</b> Role <a href=\"" . url("administrator/roles/" . $id) . "\">here</a>"
                            ];
            $this->activityLog->store($activityLog);
            
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/roles")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));
		if($auth->aplikasi == "HO") {
            $this->menuService->model->getQuery()->join("administratormenu as parent", "parent.id", "=", "administratormenu.parentmenu");
            $this->menuService->model->getQuery()->select(["administratormenu.*", "parent.menuname as parentMenu", "parent.id as parentID"])->where("administratormenu.active", "=", 1)->orderBy("parentID", "ASC");
            $this->data["access"] = $this->menuService->index();
            $this->data["lokasiitems"] = $this->lokasiitem->index($request);
            $this->data["categories"] = $this->itemcategory->index($request);
            return view("modules.roles.roles_create", $this->data);
        } else {
			return redirect()->to("administrator/roles")->with("errMessage", "Sorry, you don't have access to this page!");
		}
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $this->data["roles"] = $this->baseService->show($id);
        if($this->data["roles"]) {
            $this->menuService->model->getQuery()->join("administratormenu as parent", "parent.id", "=", "administratormenu.parentmenu");
            $this->menuService->model->getQuery()->select(["administratormenu.*", "parent.menuname as parentMenu", "parent.id as parentID"])->where("administratormenu.active", "=", 1);
            $this->data["access"] = $this->menuService->index();
            $this->data["groupHasAccess"] = (new AdministratorgroupaccessService())->model->getQuery()->where("administratorgroupaccess.groupid", "=", $this->data["roles"]->id)->get();

            $this->data["lokasiitems"] = $this->lokasiitem->index($request);
            $this->data["groupHasSubinv"] = $this->baseService->groupHasSubinv($this->data["roles"]->id);

            $this->data["categories"] = $this->itemcategory->index($request);
            $this->data["groupHasCategories"] = $this->baseService->groupHasCategories($this->data["roles"]->id);

            return view("modules.roles.roles_show", $this->data);
        } else {
            return redirect()->to("administrator/roles")->with("errMessage", "Sorry, you don't have access to this page!");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->validator->beforeDelete($ids);
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }

        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function checkrole(Request $request) {
        $input = $request->all();
        $data = $this->baseService->show($input["roleName"], "ILIKE", "roleName");
        echo json_encode($data); 
    }


}